[Top][All Lists]
[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]
Re: gzip --force bug
From: |
Jim Meyering |
Subject: |
Re: gzip --force bug |
Date: |
Thu, 04 Feb 2010 08:26:07 +0100 |
Mark Adler wrote:
> Jim,
>
> Below is a patch to the patch.
>
> A test case will be forthcoming (I need to create a case that delicately
> crosses a buffer boundary). Once I get a test case working, you can push it.
>
> By the way, I found an even more serious incarnation of the original bug
> shown by this test case:
>
> $ echo -n x | gzip124 -cdf | wc -c
> 0
> $ echo -n x | gzip14 -cdf | wc -c
> 0
>
> It should be the same as cat:
>
> $ echo -n x | cat | wc -c
> 1
> $ echo -n x | ./gzip -cdf | wc -c
> 1
>
> Test cases to add for completeness are:
>
> $ echo -n | ./gzip -cdf | wc -c
> $ echo -n x | ./gzip -cdf | wc -c
> $ echo -n xy | ./gzip -cdf | wc -c
> $ echo -n xyz | ./gzip -cdf | wc -c
>
> Those should return 0, 1, 2, and 3 respectively.
Thanks.
I've added the following test.
It tests for preserved content, too.
>From 9ff85940c4e7c35739ffda73129bfe8ab34bbc8f Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Thu, 4 Feb 2010 08:09:23 +0100
Subject: [PATCH] tests: add more tests of gzip -cdf
* tests/mixed: Test "gzip -cdf" for a range of small uncompressed files.
---
tests/mixed | 21 +++++++++++++++++++++
1 files changed, 21 insertions(+), 0 deletions(-)
diff --git a/tests/mixed b/tests/mixed
index 903a644..65898a1 100644
--- a/tests/mixed
+++ b/tests/mixed
@@ -50,4 +50,25 @@ compare out exp2 || fail=1
gzip -cdf < in > out || fail=1
compare out exp2 || fail=1
+in_str=0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_-+=%
+for i in 0 1 2 3 4 5 6 7 8 9 a; do in_str="$in_str$in_str" ;done
+
+# Start with some small sizes. $(seq 64)
+sizes=$(i=0; while :; do echo $i; test $i = 64; i=$(expr $i + 1) && break;
done)
+
+# gzip's internal buffer size is 32KiB + 64 bytes:
+sizes="$sizes 32831 32832 32833"
+
+# 128KiB, +/- 1
+sizes="$sizes 131071 131072 131073"
+
+# Ensure that "gzip -cdf" acts like cat, for a range of small input files.
+i=0
+for i in $sizes; do
+ echo $i
+ printf %$i.${i}s $in_str > in
+ gzip -cdf < in > out
+ compare in out || fail=1
+done
+
Exit $fail
--
1.7.0.rc1.193.ge8618
- gzip --force bug, Mark Adler, 2010/02/02
- Re: gzip --force bug, Jim Meyering, 2010/02/03
- Re: gzip --force bug, Mark Adler, 2010/02/03
- Re: gzip --force bug, Jim Meyering, 2010/02/03
- Re: gzip --force bug, Mark Adler, 2010/02/03
- Re: gzip --force bug, Mark Adler, 2010/02/03
- Re: gzip --force bug, Mark Adler, 2010/02/03
- Re: gzip --force bug, Mark Adler, 2010/02/03
- Re: gzip --force bug, Jim Meyering, 2010/02/04
- Re: gzip --force bug, Mark Adler, 2010/02/04
- Re: gzip --force bug,
Jim Meyering <=
- gzip 1.4 warnings, Mark Adler, 2010/02/03